'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _video = require('video.js');

var _video2 = _interopRequireDefault(_video);

require('./countdown-start-dialog.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Default options for the plugin.
var defaults = {};

/**
 * Function to invoke when the player is ready.
 *
 * This is a great place for your plugin to initialize itself. When this
 * function is called, the player will have its DOM and child components
 * in place.
 *
 * @function onPlayerReady
 * @param    {Player} player
 * @param    {Object} [options={}]
 */
var onPlayerReady = function onPlayerReady(player, options) {
  player.addClass('vjs-countdown-start');
  player.addChild('countdownStartDialog', options);
};

/**
 * A video.js plugin.
 *
 * In the plugin function, the value of `this` is a video.js `Player`
 * instance.
 *
 * @function feedback
 * @param    {Object} [options={}]
 *           An object of options left to the plugin author to define.
 */
var countdownStart = function countdownStart(options) {
  var _this = this;

  this.ready(function () {
    onPlayerReady(_this, _video2.default.mergeOptions(defaults, options));
  });
};

// Register the plugin with video.js.
_video2.default.plugin('countdownStart', countdownStart);

// Include the version number.
countdownStart.VERSION = '__VERSION__';

exports.default = countdownStart;